Buildroot Archive on lore.kernel.org
 help / color / mirror / Atom feed
From: Abhimanyu Vishwakarma <abhimanyu.v@gmail.com>
To: buildroot@busybox.net
Subject: [Buildroot] [PATCH v9 1/2] genimage.sh: fix calling from BR2_ROOTFS_POST_IMAGE_SCRIPT
Date: Sat, 22 Apr 2017 00:28:38 +0530	[thread overview]
Message-ID: <20170421185839.17905-1-abhimanyu.v@gmail.com> (raw)

From: Abhimanyu Vishwakarma <Abhimanyu.V@gmail.com>

When called from BR2_ROOTFS_POST_IMAGE_SCRIPT, this script
ends up with following error:

Error: Missing argument

This is because, extra positional argument is also passed
along with BR2_ROOTFS_POST_SCRIPT_ARGS. genimage.sh didnt
had support to parse positional and optional argument
together.

Signed-off-by: Abhimanyu Vishwakarma <Abhimanyu.V@gmail.com>
---
 Changes v7->v8
   - New file
 Changes v8->v9
   - Fix indentation
   - Use bash basename as script name instead hardcoding

 support/scripts/genimage.sh | 23 ++++++++++++++++-------
 1 file changed, 16 insertions(+), 7 deletions(-)

diff --git a/support/scripts/genimage.sh b/support/scripts/genimage.sh
index 0ed0e8bcc..a2309e224 100755
--- a/support/scripts/genimage.sh
+++ b/support/scripts/genimage.sh
@@ -1,17 +1,26 @@
 #!/bin/bash
 
 die() {
-  echo "Error: $@" >&2
-  exit 1
+	echo "Error: $@" >&2
+	exit 1
 }
 
+# Parse arguments and put into argument list of the script
+opts="$(getopt -n "${0##*/}" -o c: -- "$@")" || exit $?
+eval set -- "$opts"
+
 GENIMAGE_TMP="${BUILD_DIR}/genimage.tmp"
 
-while getopts c: OPT ; do
-	case "${OPT}" in
-	c) GENIMAGE_CFG="${OPTARG}";;
-	:) die "option '${OPTARG}' expects a mandatory argument\n";;
-	\?) die "unknown option '${OPTARG}'\n";;
+while true ; do
+	case "$1" in
+		-c)
+			GENIMAGE_CFG="${2}";
+			shift 2 ;;
+		--) # Discard all non-option parameters
+			shift 1;
+			break ;;
+		*)
+			die "unknown option '${1}'" ;;
 	esac
 done
 
-- 
2.11.0

             reply	other threads:[~2017-04-21 18:58 UTC|newest]

Thread overview: 5+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-04-21 18:58 Abhimanyu Vishwakarma [this message]
2017-04-21 18:58 ` [Buildroot] [PATCH v9 2/2] Add defconfig for MIPS Creator ci40 Abhimanyu Vishwakarma
2017-04-22  7:09   ` Rahul Bedarkar
2017-04-22  7:14 ` [Buildroot] [PATCH v9 1/2] genimage.sh: fix calling from BR2_ROOTFS_POST_IMAGE_SCRIPT Rahul Bedarkar
2017-04-23 21:27 ` Arnout Vandecappelle

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20170421185839.17905-1-abhimanyu.v@gmail.com \
    --to=abhimanyu.v@gmail.com \
    --cc=buildroot@busybox.net \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox